`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/01/27 15:22:22
// Design Name: 
// Module Name: ADC
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module ADC( 
          input     dclk_in,             // Clock input for the dynamic reconfiguration port
          input     vp_in,               // Dedicated Analog Input Pair
          input     vn_in,
          input Vconp,
          input Vconn,
          input TPAp,
          input TPAn,
          input TPAbp,
          input TPAbn,
          input TPBp,
          input TPBn,
          input TPBbp,
          input TPBbn,
          input PP18p,
          input PP18n,
          input PP33p,
          input PP33n,
                                        
                                        
          input   [7:0] INDATA1f,
          input   [7:0] INDATA20,
          input   [7:0] INDATA21,
          output  reg [7:0] OUTDATA1f,
          
          
                    
          output  reg [7:0] OUTDATA20,
          output  reg [7:0] OUTDATA21,
          input wire[15:0]di_in,
          
          //input wire     den_in,             // Enable Signal for the dynamic reconfiguration port
          //input  wire     dwe_in 
          /*,
          
          
          
          output    reg    busy_out,            // ADC Busy signal
          output    reg[4:0]channel_out,           // Channel Selection Outputs
          output    reg    drdy_out,            // Data ready signal for the dynamic reconfiguration port
          output    reg    eoc_out,             // End of Conversion Signal
          output    reg    eos_out,             // End of Sequence Signal
          output    reg    ot_out,              // Over-Temperature alarm output
          //output    reg    vccaux_alarm_out,    // VCCAUX-sensor alarm output
          //output    reg    vccint_alarm_out,    //  VCCINT-sensor alarm output
          //output    reg    user_temp_alarm_out, // Temperature-sensor alarm output
          output    reg    alarm_out*/
          
          //TP_sig
          input CLK40,
          output reg TPTRIG = 0,
            
          input   [7:0] INDATA46,
          output  reg [7:0] OUTDATA46,
          input   [7:0] INDATA47,
          output  reg [7:0] OUTDATA47,
          input   [7:0] INDATA48,
          output  reg [7:0] OUTDATA48,
          input   [7:0] INDATA49,
          output  reg [7:0] OUTDATA49
          

          );

    //for_ADC--------------------------------------------------------------------------   
          reg[6:0]daddr_in;           // Address bus for the dynamic reconfiguration port
          //wire[15:0]di_in;
          wire[15:0]do_out;              // Output data bus for dynamic reconfiguration port
          reg     den_in = 1'b0;             // Enable Signal for the dynamic reconfiguration port
          reg     dwe_in = 1'b0;              // Write Enable for the dynamic reconfiguration port
          
          //reg[15:0]di_in;               // Input data bus for the dynamic reconfiguration port
          reg     reset_in = 1'b0;      // Reset signal for the System Monitor control logic
          wire    busy_out;            // ADC Busy signal
          wire[4:0]channel_out;           // Channel Selection Outputs
          wire    drdy_out;      // Data ready signal for the dynamic reconfiguration port
          wire    eoc_out;             // End of Conversion Signal
          wire    eos_out;             // End of Sequence Signal
          //wire    ot_out;              // Over-Temperature alarm output
          //reg    vccaux_alarm_out;    // VCCAUX-sensor alarm output
          //reg    vccint_alarm_out;    //  VCCINT-sensor alarm output
          //reg    user_temp_alarm_out; // Temperature-sensor alarm output
          wire    alarm_out;
    //for_ADC--------------------------------------------------------------------------    

   reg convst_in = 1'b0;
   reg rst_cont = 2'b00;

   //for_ADC_trigger--------------------------------------------------------------------------
   reg [31:0] s_cont = 32'h00000000;
   reg [31:0] t_cont = 32'h00000000;
     
     always@(posedge dclk_in)begin //dclk_in
      
      if((INDATA21[7:0] == 8'h01)||(INDATA21[7:0] == 8'h02)||(INDATA21[7:0] == 8'h03)) begin
      
        if(INDATA20[7:0] == 8'h03) begin
            s_cont <= 32'h0;
            convst_in <= 1'b0;
        end
     
        else if(INDATA1f[7:0] == 8'h03) begin
             if(convst_in == 0 && s_cont == 32'h00000000) begin 
                convst_in <= 1;
                s_cont <= 32'h00000001;
                OUTDATA1f[7:0] <= 8'b0;
                OUTDATA20[7:0] <= 8'b0;
             end
             else if(convst_in == 1 && s_cont == 32'h00000001) begin 
                   convst_in <= 0;
                   s_cont <= s_cont + 32'h1;
             end
             else if(convst_in == 0 && s_cont == 32'h00000002) begin 
                   convst_in <= 0;
                   den_in <= 1;
                   s_cont <= s_cont + 32'h1;
                   if(INDATA21 == 8'h01) daddr_in <= 7'h10;//Vcon
                   else if(INDATA21 == 8'h02) daddr_in <= 7'h19;//PP33
                   else if(INDATA21 == 8'h03) daddr_in <= 7'h18;//PP18
             end
             else if(convst_in == 0 && s_cont == 32'h00000003) begin 
                   den_in <= 0;
                   s_cont <= s_cont + 32'h1;
             end
             else if(convst_in == 0 && s_cont == 32'h00000004) begin 
                   den_in <= 0;
                   s_cont <= s_cont + 32'h1;
             end
             else if (32'h00000004 < t_cont < 32'h000005b4)begin//4ba
                   t_cont <= t_cont + 32'h1;
                   if (eoc_out ==1)begin
                       OUTDATA1f[7:4] <= 4'h0;
                       OUTDATA1f[3:0] <= do_out [15:12];
                       OUTDATA20[7:0] <= do_out [11:4];
                   end
             end
             else if (s_cont == 32'h00000100/*l̗]n*/ ) begin
             s_cont <= s_cont;
             end
             else s_cont <= s_cont + 32'h1;
        end
        else begin
            s_cont <= 32'h0;
            convst_in <= 1'b0;
        end
      end
      
      
      else if((INDATA21[7:0] == 8'h04)||(INDATA21[7:0] == 8'h05)||(INDATA21[7:0] == 8'h06)||(INDATA21[7:0] == 8'h07)) begin
      
      
        if(INDATA20[7:0] == 8'h03) begin
             t_cont <= 32'h0;
             TPTRIG <= 1'b0;
        end
       //for_start_one_shot_TPTRIG              
        else if(INDATA1f[7:0] == 8'h03) begin
            if(TPTRIG == 1'b0 && t_cont == 32'h00000000) begin
                TPTRIG <= 1'b1;
            end
            else if(TPTRIG == 1'b1 && t_cont == 32'h00000010) begin 
                TPTRIG <= 1'b0;
                t_cont <= t_cont + 32'h1;
            end
        else if(TPTRIG == 1'b1) begin 
            TPTRIG <= 1'b1;
            t_cont <= t_cont + 32'h1;
        end
        
        if(convst_in == 0 && t_cont == 32'h000007d0) begin 
            convst_in <= 1;
            t_cont <= 32'h000007d1;
            OUTDATA1f[7:0] <= 8'b0;
            OUTDATA20[7:0] <= 8'b0;
        end
        else if(convst_in == 1 && t_cont == 32'h000007d1) begin 
            convst_in <= 0;
            t_cont <= t_cont + 32'h1;
        end
        else if(convst_in == 0 && t_cont == 32'h000007d2) begin 
            convst_in <= 0;
            den_in <= 1;
            t_cont <= t_cont + 32'h1;
            if(INDATA21 == 8'h04) daddr_in <= 7'h12;//TA
            else if(INDATA21 == 8'h05) daddr_in <= 7'h1a;//TA_
            else if(INDATA21 == 8'h06) daddr_in <= 7'h1b;//TB
            else if(INDATA21 == 8'h07) daddr_in <= 7'h13;//TB_
        end
        else if(convst_in == 0 && t_cont == 32'h000007d3) begin 
            den_in <= 0;
            t_cont <= t_cont + 32'h1;
        end
        else if (32'h000007d3 < t_cont < 32'h00000d84)begin//4ba
        t_cont <= t_cont + 32'h1;
         if (eoc_out ==1)begin
               OUTDATA1f[7:4] <= 4'h0;
               OUTDATA1f[3:0] <= do_out [15:12];
               OUTDATA20[7:0] <= do_out [11:4];
         end
        end
        else if (t_cont == 32'h00001000 ) begin
            t_cont = t_cont;
        end
        else t_cont <= t_cont + 32'h1;
      end
      else begin
            t_cont <= 32'h0;
            TPTRIG <= 1'b0;
            convst_in <= 1'b0;
      end
      
      end
      
           
           
      end


    //----------------------------------------------------------------------------------------
    
    
   

xadc_wiz_0 xadc_wiz_inst (
      //.convst_in(convst_in),           // Convert Start Input
      .daddr_in(daddr_in[6:0]),
      .dclk_in(dclk_in),
      .den_in(den_in),
      .di_in(di_in[15:0]),
      .dwe_in(dwe_in),
      .reset_in(reset_in),
      .vauxp0(Vconp),              // Auxiliary channel 0
      .vauxn0(Vconn),
      .vauxp2(TPAp),              // Auxiliary channel 2
      .vauxn2(TPAn),
      .vauxp3(TPBbp),
      .vauxn3(TPBbn),
      .vauxp8(PP18p), 
      .vauxn8(PP18n),
      .vauxp9(PP33p), 
      .vauxn9(PP33n),
      .vauxp10(TPAbp), 
      .vauxn10(TPAbn),
      .vauxp11(TPBp), 
      .vauxn11(TPBn),
                        
      .vp_in(vp_in),
      .vn_in(vn_in),                              
 
      //.vccaux_alarm_out(vccaux_alarm_out),
      //.vccint_alarm_out(vccint_alarm_out),
      //.user_temp_alarm_out(user_temp_alarm_out),
      .busy_out(busy_out),
      .channel_out(channel_out[4:0]),
      .do_out(do_out[15:0]),
      .drdy_out(drdy_out),
      .eoc_out(eoc_out),
      .eos_out(eos_out),
      //.ot_out(ot_out),
      .alarm_out(alarm_out)
      );
      
      

endmodule
