`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/01/20 10:07:54
// Design Name: 
// Module Name: SPI
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module SPI(
    input             CLK,
    input             RST,
    input             START,
    input  [223:0]      TXDATA,
    input             RXSIG,
    input [7:0]       INDATA4e,
    output reg[0:0]   TXSIG = 0,
    output reg[223:0]   RXDATA,
    output reg        SPICLK = 0,
    output reg        SS_b =1
);

reg[223:0] txbuff;
reg[223:0] rxbuff  = 224'b0;
reg[8:0] clkCnt  = 9'b0;
reg[7:0] dataCnt = 8'b0;

parameter CLKFLAG = 9'd4;//CLK/(SPICLK*2)  40MHz/(5MHz/2)
parameter DATAFLAG = 9'd8;//CLK/SPICLK       ex)40MHz/5MHz

always@(posedge CLK /*or negedge RST*/)begin
    if(RST == 1)begin
        txbuff  <= 224'b0;
        rxbuff  <= 224'b0;
        SS_b    <= 1;
        SPICLK  <= 0;
        clkCnt  <= 9'b0;
    end
    else if(INDATA4e == 8'h03) begin
        SS_b    <= 0;
    end
    else begin
        if(SS_b == 0)begin
            clkCnt <= clkCnt + 9'b1;
            
            if(START == 1 & clkCnt == 9'd0)begin //͂߂̂P̂
            TXSIG   <= txbuff[223];
            txbuff[223:0]  <= {txbuff[222:0],1'b0};
            end
            
            else if(clkCnt == CLKFLAG)begin
                SPICLK <= ~SPICLK;
                if(!SPICLK)begin
                    rxbuff[223:0] <= {rxbuff[222:0],1'b0};
                    rxbuff[0]   <= RXSIG;
                    dataCnt     <= dataCnt + 8'b1;
                end
            end
            
            else if(clkCnt == DATAFLAG)begin
                if(dataCnt < 8'hE0)begin
                    clkCnt <= 9'b000000001;//9'b0ł
                    SPICLK <= ~SPICLK;
                    TXSIG  <= txbuff[223];
                    txbuff[223:0] <= {txbuff[222:0],1'b0};
                end
                else if(dataCnt == 8'hE0)begin
                    RXDATA[223:0]  <= rxbuff[223:0];
                    SPICLK  <= 0;
                    TXSIG   <= 0;
                end
            end
            else if(clkCnt == DATAFLAG + 9'b1)begin
                   txbuff[223:0]  <= 224'b0;
                   rxbuff[223:0]  <= 224'b0;
                   SS_b    <= 1;
                   clkCnt  <= 9'b0;
                   dataCnt <= 8'h0;
            end
        end
        else if(SS_b == 1)begin
            if(START == 1)begin
                txbuff[223:0]  <= TXDATA[223:0];
                rxbuff[223:0]  <= 224'b0;
                SS_b    <= 0;
                clkCnt  <= 9'b0;
                dataCnt <= 8'b0;
                //SPICLK  <= 0;
            end
        end
    end
end
    
   
   
endmodule